#! python3

from teraFAST import processor as tp
from teraFAST import worker as tw

def ticker(progress):
    """Progress indicator. To abort process, return (False, False) tuple. """
    if progress < 100:
        print(".",end='')
    else:
        print(" ")
    return (True, False)

def main():
    frameLength = 256 #number of lines returned per frame
    source = tp.processor(rows=frameLength)
    input("Prepare to record background. Switch off incoming radiation and press Enter")
    # Background is recorded.
    source.RecordBG(callback = ticker)
    input("Prepare to record normalization. Switch on incoming radiation and press Enter")
    # Normalization is recorded. The recorded normalization is automatically selected.
    source.RecordNorm(callback = ticker)
    # You may want to use SaveConfig/LoadConfig to avoid repeating recording background/normalization procedure.
    #You need to start data acquisition explicitly
    source.start()
    for i in range(100):
        data = source.read()
        #do something with image
        print(data.shape)
    #Call stop() to stop acquisition and join the acquisition and processing thread
    source.stop()
if __name__ == '__main__':
    main()
