#! python3
# example of working with two devices simultaneously

import teraFAST.processor as tp
import msvcrt, sys


def cb(a):
    if a is not None:
        for i in range(a.shape[1]):
            print("\t".join(list(map(str,a[:,i]))))
    else:
        print("None", file=sys.stderr)


def main():
           
    proc1 = tp.processor(rows = 128)   #add sn parameter to choose a specific device
    proc2 = tp.processor(rows = 512)   #add sn parameter to choose a specific device

    print("sn1=", proc1.GetID(), file=sys.stderr)
    print("sn2=",proc2.GetID(), file=sys.stderr)

    
    
  
    
##    proc1.start(callback = cb)
##    proc.start(callback = cb)

    proc1.start()    
    proc2.start()     

    while True:
        print(".",end="",file=sys.stderr, flush=True)
        
        
        a = proc1.read()
        b = proc2.read()
        
        if a is not None:
            print(a.shape)
##            for i in range(a.shape[1]):
##                    print("\t".join(list(map(str,a[:,i]))), flush=True)
        else:
            print("Err", end="", file=sys.stderr, flush=True)
        if b is not None:
            print(b.shape)
##            for i in range(b.shape[1]):
##                    print("\t".join(list(map(str,b[:,i]))), flush=True)
        else:
            print("Err", end="",file=sys.stderr, flush=True)
            
        if msvcrt.kbhit() and ord(msvcrt.getch()) == 27:
            break
        

    proc1.stop(True)
    proc2.stop(True)
    print("\nstop", file=sys.stderr)


if __name__ == '__main__':
    main()
