__svn_revision__ = '$Revision: 432 $'

#
# MSP430 text code format loader
#

def load(fd):
	"""
	Load segments from the specified file descriptor.
	Returns the list of (addr, code) tuples.
	"""
	segs = []
	addr = None
	data = None
	ls = fd.readlines()
	try:
		for l in ls:
			if l[0] == '@':
				if addr != None:
					segs += (addr, data)
				addr = int(l[1:], base=16)
				data = ''
			elif l[0] == 'q':
				if addr is None:
					return None
				segs.append((addr, data),)
				return segs
			else:
				bytes = l.split()
				for b in bytes:
					data += chr(int(b, base=16))
	except:
		pass
	return None

def load_file(path):
	"""Load specified file"""
	f = None
	try:
		f = open(path)
		return load(f)
	except:
		return None
	finally:
		if f is not None:
			f.close()
